package przyklady.emps.obiektowo;

import java.util.HashSet;
import java.util.List;
import java.util.Objects;
import java.util.Set;

import przyklady.emps.Employee;
import przyklady.emps.ObslugaCSV;

public class Grupowanie1 {
	// Ta wersja nie jest optymalnie wydajna, dla 107 pracowników i 19 stanowisk
	// pracowników przeglądamy 20 * 107 razy.
	
	public static void main(String[] args) {
		List<Employee> employees = ObslugaCSV.wczytaj("pracownicy.csv");
		
		// etap 1: ustalenie jakie są stanowiska (jobs) wśród pracowników
		Set<String> jobs = new HashSet<>();
		for (Employee emp : employees) {
			jobs.add(emp.getJobTitle());
		}
		
		System.out.println("Zebrane nazwy stanowisk (" + jobs.size() + "):");
		System.out.println(jobs);
		System.out.println();
		
		// etap 2: dla każdego stanowiska wyliczenie średniej
		for (String job : jobs) {
			double suma = 0;
			int ilosc = 0;
			
			for (Employee emp : employees) {
				if (Objects.equals(emp.getJobTitle(), job)) {
					suma += emp.getSalary();
					ilosc++;
				}
			}
			
			double srednia = suma / ilosc;
			System.out.printf("| %32s | %2d | %8.2f |\n", job, ilosc, srednia);
		}
	}

}
