package przyklady.emps.obiektowo;

import java.util.HashSet;
import java.util.List;
import java.util.Objects;
import java.util.Set;

import przyklady.emps.Employee;
import przyklady.emps.ObslugaCSV;

public class Grupowanie1_poprawione {
	public static void main(String[] args) {
		List<Employee> employees = ObslugaCSV.wczytaj("pracownicy.csv");
		
		Set<String> jobs = zbierzNazwyStanowisk(employees);
		
		System.out.println("Zebrane nazwy stanowisk (" + jobs.size() + "):");
		System.out.println(jobs);
		System.out.println();
		
		for (String job : jobs) {
			obliczDlaStanowiska(employees, job);
		}
	}

	private static Set<String> zbierzNazwyStanowisk(List<Employee> employees) {
		Set<String> jobs = new HashSet<>();
		for (Employee emp : employees) {
			jobs.add(emp.getJobTitle());
		}
		return jobs;
	}

	private static void obliczDlaStanowiska(List<Employee> employees, String job) {
		double suma = 0;
		int ilosc = 0;
		
		for (Employee emp : employees) {
			if (Objects.equals(emp.getJobTitle(), job)) {
				suma += emp.getSalary();
				ilosc++;
			}
		}
		
		double srednia = suma / ilosc;
		System.out.printf("| %32s | %2d | %8.2f |\n", job, ilosc, srednia);
	}
}
