package przyklady.emps.obiektowo;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import przyklady.emps.Employee;
import przyklady.emps.ObslugaCSV;

// Klasyczny schemat grupowania za pomocą słowników.
// Używam wyłącznie starych operacji słownikowych dostępnych od Javy 5.
public class Grupowanie2 {
	public static void main(String[] args) {
		List<Employee> employees = ObslugaCSV.wczytaj("pracownicy.csv");
		
		Map<String, Double> sumy = new HashMap<>();
		Map<String, Integer> ilosci = new HashMap<>();
		
		for (Employee emp : employees) {
			String jobTitle = emp.getJobTitle();
			if(sumy.containsKey(jobTitle)) {
				double sumaDoTejPory = sumy.get(jobTitle);
				sumy.put(jobTitle, sumaDoTejPory + emp.getSalary());
				int iloscDoTejPory = ilosci.get(jobTitle);
				ilosci.put(jobTitle, iloscDoTejPory + 1);
			} else {
				sumy.put(jobTitle, (double)emp.getSalary());
				ilosci.put(jobTitle, 1);
			}
		}

		for (String job : sumy.keySet()) {
			double suma = sumy.get(job);
			int ilosc = ilosci.get(job);
			double srednia = suma / ilosc;
			System.out.printf("| %32s | %2d | %8.2f |\n", job, ilosc, srednia);
		}
	}

}
