package przyklady.emps.obiektowo;

import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import przyklady.emps.Employee;
import przyklady.emps.ObslugaCSV;

// W tej wersji używamy nowej operacji od Java 8: getOrDefault. Dzięki temu nie piszemy if-a
public class Grupowanie3 {
	public static void main(String[] args) {
		List<Employee> employees = ObslugaCSV.wczytaj("pracownicy.csv");
		
		Map<String, Double> sumy = new TreeMap<>();
		Map<String, Integer> ilosci = new TreeMap<>();
		
		for (Employee emp : employees) {
			String jobTitle = emp.getJobTitle();
			double sumaDoTejPory = sumy.getOrDefault(jobTitle, 0.0);
			sumy.put(jobTitle, sumaDoTejPory + emp.getSalary());
			int iloscDoTejPory = ilosci.getOrDefault(jobTitle, 0);
			ilosci.put(jobTitle, iloscDoTejPory + 1);
		}

		for (String job : sumy.keySet()) {
			double suma = sumy.get(job);
			int ilosc = ilosci.get(job);
			double srednia = suma / ilosc;
			System.out.printf("| %32s | %2d | %8.2f |\n", job, ilosc, srednia);
		}
	}

}
