package przyklady.emps.obiektowo;

import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import przyklady.emps.Employee;
import przyklady.emps.ObslugaCSV;

// W tej wersji używamy nowej operacji od Java 8: putIfAbsent. Dzięki temu nie piszemy if-a
// Przy okazji: zamiast pary operacji get / put używamy nowej operacji compute(IfPresent)
public class Grupowanie4 {
	public static void main(String[] args) {
		List<Employee> employees = ObslugaCSV.wczytaj("pracownicy.csv");
		
		Map<String, Double> sumy = new TreeMap<>();
		Map<String, Integer> ilosci = new TreeMap<>();
		
		for (Employee emp : employees) {
			String jobTitle = emp.getJobTitle();
			
			sumy.putIfAbsent(jobTitle, 0.0);
			ilosci.putIfAbsent(jobTitle, 0);
			
			sumy.computeIfPresent(jobTitle, (klucz, wartosc) -> wartosc + emp.getSalary());
			ilosci.computeIfPresent(jobTitle, (klucz, wartosc) -> wartosc + 1);
		}

		for (String job : sumy.keySet()) {
			double suma = sumy.get(job);
			int ilosc = ilosci.get(job);
			double srednia = suma / ilosc;
			System.out.printf("| %32s | %2d | %8.2f |\n", job, ilosc, srednia);
		}
	}

}

/* tłumaczenie jak działa compute:
	{
	int wartosc = sumy.get(jobTitle);
	sumy.put(jobTitle, wartosc + emp.getSalary());
	}
	
	sumy.computeIfPresent(jobTitle, (klucz, wartosc) -> wartosc + emp.getSalary());			
*/
