package przyklady.emps.obiektowo;

import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import przyklady.emps.Employee;
import przyklady.emps.ObslugaCSV;

// W tej wersji używamy nowej operacji od Java 8: merge. Ona robi dokładnie to, o co chodzi w tym zadaniu :)
public class Grupowanie5 {
	public static void main(String[] args) {
		List<Employee> employees = ObslugaCSV.wczytaj("pracownicy.csv");
		
		Map<String, Double> sumy = new TreeMap<>();
		Map<String, Integer> ilosci = new TreeMap<>();
		
		for (Employee emp : employees) {
			sumy.merge(emp.getJobTitle(), (double)emp.getSalary(), Double::sum);
			ilosci.merge(emp.getJobTitle(), 1, Integer::sum);
		}

		for (String job : sumy.keySet()) {
			double suma = sumy.get(job);
			int ilosc = ilosci.get(job);
			double srednia = suma / ilosc;
			System.out.printf("| %32s | %2d | %8.2f |\n", job, ilosc, srednia);
		}
	}

}
