package przyklady.emps.obiektowo;

import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import przyklady.emps.Employee;
import przyklady.emps.ObslugaCSV;

// W tej wersji używamy nowej operacji od Java 8: merge. Ona robi dokładnie to, o co chodzi w tym zadaniu :)
public class Grupowanie5a {
	public static void main(String[] args) {
		List<Employee> employees = ObslugaCSV.wczytaj("pracownicy.csv");
		
		Map<String, Double> sumy = new TreeMap<>();
		Map<String, Integer> ilosci = new TreeMap<>();
		
		for (Employee emp : employees) {
			ilosci.merge(emp.getJobTitle(), 1, (x,y) -> x+y);
			sumy.merge(emp.getJobTitle(), (double)emp.getSalary(), (staraWartosc, zmiana) -> staraWartosc + zmiana);			
            // merge:
            // 1) jeśli danego klucza jeszcze nie ma, wstawia podaną wartość, tutaj salary
            // 2) jeśli taki klucz już jest, to podana funkcja jest wywoływana dla argumentów:
            //    ("stara wartość ze słownika", "wartość podana tutaj", czyli salary.
            //    wynik tej funkcji jest wstawiany do mapy jako nowa wartość
		}

		for (String job : sumy.keySet()) {
			double suma = sumy.get(job);
			int ilosc = ilosci.get(job);
			double srednia = suma / ilosc;
			System.out.printf("| %32s | %2d | %8.2f |\n", job, ilosc, srednia);
		}
	}

}
